
/* --------------------------------------------------------------------  */
/*                                                                       */
/*                         Author: Clyde Hoover                          */
/*                          Computation Center                           */
/*                   The University of Texas at Austin                   */
/*                          Austin, Texas 78712                          */
/*                         clyde@emx.utexas.edu                          */
/*                   uunet!cs.utexas.edu!ut-emx!clyde                    */
/*                                                                       */
/*This code may be distributed freely, provided this notice is retained. */
/*                                                                       */
/* --------------------------------------------------------------------  */
/*
 *	pwck_crack - Look in the forbidden password dictionaries
 *		using crack-rules.
 *	Returns:
 *		PWCK_INDICT if <password> was in any dictionary
 *		PWCK_OK if not
 */

#ifndef lint
static char sccsid[] = "@(#)pwck_cracklib.c	1.2 11/26/90 (cc.utexas.edu)";
#endif

#include "checkpasswd.h"

dictionary	*dictionaries = 0;	/* List of dictionaries */
static char	*egrep = "PATH=/bin:/usr/bin:/usr/ucb; egrep -s"; /* egrep */

pwck_cracklib(password, userid, mesgbuf)
char	*password;	/* Password to check */
int	userid;		/* NOTUSED */
char	*mesgbuf;	/* Message buffer */
{
	int	rcode;		/* Return code temp */
	char	*p;		/* Scratch */
	dictionary *d;		/* Current dictionary */

	/*
	 * If there are any non-alpha characters 
	 * don't bother with the dictionary checks.
	 */
	for (p = password; *p; p++) {
		if (!isalpha(*p))
			return(PWCK_OK);
	}
#ifdef	DEBUG
	printf("pwck_cracklib: \"%s\"\n", password);
#endif
	for (d = dictionaries; d; d = d->dict_next) {
#ifdef	DEBUG
		printf("\tdictionary '%s'\n", d->dict_path);
#endif
		if (p = FascistCheck(password, d->dict_path)){
			(void) strcpy(mesgbuf, p);
			return(PWCK_INDICT);
		}
	}
	return(PWCK_OK);
}
